<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Morphology.Utils</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier">Lexeme</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier">InflectedWord</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#Suffix"><span class="hs-identifier">Suffix</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInVowel"><span class="hs-identifier">ifEndsInVowel</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInA"><span class="hs-identifier">ifEndsInA</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInK"><span class="hs-identifier">ifEndsInK</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInN"><span class="hs-identifier">ifEndsInN</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInR"><span class="hs-identifier">ifEndsInR</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier">endsInSuffixes</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-11"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-12"></span><span class="hs-keyword">where</span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.List</span></span><span>
</span><span id="line-15"></span><span>
</span><span id="line-16"></span><span class="hs-keyword">type</span><span> </span><span id="Lexeme"><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-var">Lexeme</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-17"></span><span>
</span><span id="line-18"></span><span class="hs-keyword">type</span><span> </span><span id="InflectedWord"><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-var">InflectedWord</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-19"></span><span>
</span><span id="line-20"></span><span class="hs-keyword">type</span><span> </span><span id="Suffix"><span class="annot"><a href="Morphology.Utils.html#Suffix"><span class="hs-identifier hs-var">Suffix</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-21"></span><span>
</span><span id="line-22"></span><span class="annot"><a href="Morphology.Utils.html#vowels"><span class="hs-identifier hs-type">vowels</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span class="hs-special">]</span><span>
</span><span id="line-23"></span><span id="vowels"><span class="annot"><span class="annottext">vowels :: [String]
</span><a href="Morphology.Utils.html#vowels"><span class="hs-identifier hs-var hs-var">vowels</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;a&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;e&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;i&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;o&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;u&quot;</span></span><span class="hs-special">]</span><span>
</span><span id="line-24"></span><span>
</span><span id="line-25"></span><span class="hs-comment">-- | If given word has indicated ending, apply first function; otherwise,</span><span>
</span><span id="line-26"></span><span class="hs-comment">--  apply second function</span><span>
</span><span id="line-27"></span><span class="annot"><a href="Morphology.Utils.html#ifEndsInVowel"><span class="hs-identifier hs-type">ifEndsInVowel</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-28"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInA"><span class="hs-identifier hs-type">ifEndsInA</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-29"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInK"><span class="hs-identifier hs-type">ifEndsInK</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-30"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInN"><span class="hs-identifier hs-type">ifEndsInN</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-31"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#ifEndsInR"><span class="hs-identifier hs-type">ifEndsInR</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-32"></span><span>    </span><span class="hs-special">(</span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-33"></span><span>    </span><span class="hs-special">(</span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-34"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-35"></span><span>    </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-36"></span><span id="ifEndsInVowel"><span class="annot"><span class="annottext">ifEndsInVowel :: (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#ifEndsInVowel"><span class="hs-identifier hs-var hs-var">ifEndsInVowel</span></a></span></span><span> </span><span id="local-6989586621679081894"><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081894"><span class="hs-identifier hs-var">optionA</span></a></span></span><span> </span><span id="local-6989586621679081893"><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081893"><span class="hs-identifier hs-var">optionB</span></a></span></span><span> </span><span id="local-6989586621679081892"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081892"><span class="hs-identifier hs-var">word</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-keyword">if</span><span> </span><span class="annot"><span class="annottext">String -&gt; Bool
</span><a href="Morphology.Utils.html#endsInVowel"><span class="hs-identifier hs-var">endsInVowel</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081892"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-38"></span><span>    </span><span class="hs-keyword">then</span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081894"><span class="hs-identifier hs-var">optionA</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081892"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-39"></span><span>    </span><span class="hs-keyword">else</span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081893"><span class="hs-identifier hs-var">optionB</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081892"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-40"></span><span id="ifEndsInA"><span class="annot"><span class="annottext">ifEndsInA :: (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#ifEndsInA"><span class="hs-identifier hs-var hs-var">ifEndsInA</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
-&gt; (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var">endingBasedInflection</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;a&quot;</span></span><span>
</span><span id="line-41"></span><span id="ifEndsInK"><span class="annot"><span class="annottext">ifEndsInK :: (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#ifEndsInK"><span class="hs-identifier hs-var hs-var">ifEndsInK</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
-&gt; (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var">endingBasedInflection</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;k&quot;</span></span><span>
</span><span id="line-42"></span><span id="ifEndsInR"><span class="annot"><span class="annottext">ifEndsInR :: (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#ifEndsInR"><span class="hs-identifier hs-var hs-var">ifEndsInR</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
-&gt; (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var">endingBasedInflection</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;r&quot;</span></span><span>
</span><span id="line-43"></span><span id="ifEndsInN"><span class="annot"><span class="annottext">ifEndsInN :: (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#ifEndsInN"><span class="hs-identifier hs-var hs-var">ifEndsInN</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
-&gt; (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var">endingBasedInflection</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;n&quot;</span></span><span>
</span><span id="line-44"></span><span>
</span><span id="line-45"></span><span class="hs-comment">-- | Given a list of suffixes and a word, checks whether the word</span><span>
</span><span id="line-46"></span><span class="hs-comment">-- ends in any of the suffixes</span><span>
</span><span id="line-47"></span><span class="annot"><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier hs-type">endsInSuffixes</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Morphology.Utils.html#Suffix"><span class="hs-identifier hs-type">Suffix</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Bool</span></span><span>
</span><span id="line-48"></span><span id="endsInSuffixes"><span class="annot"><span class="annottext">endsInSuffixes :: [String] -&gt; String -&gt; Bool
</span><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier hs-var hs-var">endsInSuffixes</span></a></span></span><span> </span><span id="local-6989586621679081889"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679081889"><span class="hs-identifier hs-var">suffixes</span></a></span></span><span> </span><span id="local-6989586621679081888"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081888"><span class="hs-identifier hs-var">word</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((String -&gt; Bool) -&gt; Bool) -&gt; [String -&gt; Bool] -&gt; Bool
forall (t :: * -&gt; *) a. Foldable t =&gt; (a -&gt; Bool) -&gt; t a -&gt; Bool
</span><span class="hs-identifier hs-var">any</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(String -&gt; Bool) -&gt; String -&gt; Bool
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081888"><span class="hs-identifier hs-var">word</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[String -&gt; Bool]
</span><a href="#local-6989586621679081886"><span class="hs-identifier hs-var">suffixEndings</span></a></span><span>
</span><span id="line-49"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-50"></span><span>    </span><span id="local-6989586621679081886"><span class="annot"><span class="annottext">suffixEndings :: [String -&gt; Bool]
</span><a href="#local-6989586621679081886"><span class="hs-identifier hs-var hs-var">suffixEndings</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(String -&gt; String -&gt; Bool) -&gt; [String] -&gt; [String -&gt; Bool]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; String -&gt; Bool
forall a. Eq a =&gt; [a] -&gt; [a] -&gt; Bool
</span><span class="hs-identifier hs-var">isSuffixOf</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679081889"><span class="hs-identifier hs-var">suffixes</span></a></span><span>
</span><span id="line-51"></span><span>
</span><span id="line-52"></span><span class="annot"><a href="Morphology.Utils.html#endsInVowel"><span class="hs-identifier hs-type">endsInVowel</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Bool</span></span><span>
</span><span id="line-53"></span><span id="endsInVowel"><span class="annot"><span class="annottext">endsInVowel :: String -&gt; Bool
</span><a href="Morphology.Utils.html#endsInVowel"><span class="hs-identifier hs-var hs-var">endsInVowel</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; String -&gt; Bool
</span><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier hs-var">endsInSuffixes</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="Morphology.Utils.html#vowels"><span class="hs-identifier hs-var">vowels</span></a></span><span>
</span><span id="line-54"></span><span>
</span><span id="line-55"></span><span class="hs-comment">-- if ends in X, do P, else Q</span><span>
</span><span id="line-56"></span><span class="hs-comment">-- if prefix is empty, it will be optionA</span><span>
</span><span id="line-57"></span><span class="annot"><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-type">endingBasedInflection</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-58"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#Suffix"><span class="hs-identifier hs-type">Suffix</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-61"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-62"></span><span>  </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-63"></span><span id="endingBasedInflection"><span class="annot"><span class="annottext">endingBasedInflection :: String
-&gt; (String -&gt; String) -&gt; (String -&gt; String) -&gt; String -&gt; String
</span><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var hs-var">endingBasedInflection</span></a></span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-64"></span><span class="annot"><a href="Morphology.Utils.html#endingBasedInflection"><span class="hs-identifier hs-var">endingBasedInflection</span></a></span><span> </span><span id="local-6989586621679081884"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081884"><span class="hs-identifier hs-var">suffix</span></a></span></span><span> </span><span id="local-6989586621679081883"><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081883"><span class="hs-identifier hs-var">optionA</span></a></span></span><span> </span><span id="local-6989586621679081882"><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081882"><span class="hs-identifier hs-var">optionB</span></a></span></span><span> </span><span id="local-6989586621679081881"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081881"><span class="hs-identifier hs-var">word</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-65"></span><span>  </span><span class="hs-keyword">if</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081884"><span class="hs-identifier hs-var">suffix</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; String -&gt; Bool
forall a. Eq a =&gt; [a] -&gt; [a] -&gt; Bool
</span><span class="hs-operator hs-var">`isSuffixOf`</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081881"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-66"></span><span>    </span><span class="hs-keyword">then</span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081883"><span class="hs-identifier hs-var">optionA</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081881"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-67"></span><span>    </span><span class="hs-keyword">else</span><span> </span><span class="annot"><span class="annottext">String -&gt; String
</span><a href="#local-6989586621679081882"><span class="hs-identifier hs-var">optionB</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081881"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-68"></span></pre></body></html>